if (!defined &_SYS_FS_S5_INODE_H) {
    eval 'sub _SYS_FS_S5_INODE_H {1;}';
    require 'sys/fbuf.ph';
    require 'sys/fcntl.ph';
    require 'sys/uio.ph';
    require 'sys/t_lock.ph';
    require 'sys/fs/s5_fs.ph';
    require 'sys/fs/s5_lockfs.ph';
    if (defined &__cplusplus) {
    }
    eval 'sub NADDR {13;}';
    eval 'sub NDADDR {10;}';
    eval 'sub NIADDR {( &NADDR- &NDADDR);}';
    eval 'sub NSADDR {( &NADDR * $sizeof{ &daddr_t}/$sizeof{\'short\'});}';
    eval 'sub NINDIR {
        local($s5vfs) = @_;
        eval "(($s5vfs)-> &vfs_bsize / $sizeof{ &daddr_t})";
    }';
    eval 'sub i_fs { &i_s5vfs-> &vfs_bufp-> &b_un. &b_fs;}';
    eval 'sub i_oldrdev { &i_addr[0];}';
    eval 'sub i_bcflag { &i_addr[1];}';
    eval 'sub NDEVFORMAT {0x1;}';
    eval 'sub i_major { &i_addr[2];}';
    eval 'sub i_minor { &i_addr[3];}';
    eval 'sub INOACC {0x0001;}';
    eval 'sub IUPD {0x0002;}';
    eval 'sub IACC {0x0004;}';
    eval 'sub IREF {0x0010;}';
    eval 'sub ICHG {0x0040;}';
    eval 'sub ISYN {0x0080;}';
    eval 'sub IMOD {0x0100;}';
    eval 'sub IMODACC {0x0200;}';
    eval 'sub ISYNC {0x0400;}';
    eval 'sub IMODTIME {0x0800;}';
    eval 'sub IINACTIVE {0x2000;}';
    eval 'sub IFMT {0xF000;}';
    eval 'sub IFIFO {0x1000;}';
    eval 'sub IFCHR {0x2000;}';
    eval 'sub IFDIR {0x4000;}';
    eval 'sub IFNAM {0x5000;}';
    eval 'sub IFBLK {0x6000;}';
    eval 'sub IFREG {0x8000;}';
    eval 'sub IFLNK {0xA000;}';
    eval 'sub ISUID { &VSUID;}';
    eval 'sub ISGID { &VSGID;}';
    eval 'sub ISVTX { &VSVTX;}';
    eval 'sub IREAD { &VREAD;}';
    eval 'sub IWRITE { &VWRITE;}';
    eval 'sub IEXEC { &VEXEC;}';
    eval 'sub I_SYNC {1;}';
    eval 'sub I_ASYNC {0;}';
    if (defined &_KERNEL) {
	eval 'sub VTOI {
	    local($VP) = @_;
	    eval "(($VP)-> &v_data)";
	}';
	eval 'sub ITOV {
	    local($IP) = @_;
	    eval "(&($IP)-> &i_vnode)";
	}';
	eval 'sub ITOF {
	    local($IP) = @_;
	    eval "(($IP)-> &i_fs)";
	}';
	eval 'sub vfs_fs { &vfs_bufp-> &b_un. &b_fs;}';
	eval 'sub INOHSZ {512;}';
	if ((( &INOHSZ & ( &INOHSZ - 1)) == 0)) {
	    eval 'sub INOHASH {
	        local($dev, $ino) = @_;
	        eval "( &hash2ints($dev, $ino) &  &INOHSZ - 1)";
	    }';
	}
	else {
	    eval 'sub INOHASH {
	        local($dev, $ino) = @_;
	        eval "( &hash2ints($dev, $ino) %  &INOHSZ)";
	    }';
	}
	eval 'sub IMARK {
	    local($ip) = @_;
	    eval " &s5_imark($ip)";
	}';
	eval 'sub ITIMES_NOLOCK {
	    local($ip) = @_;
	    eval " &s5_itimes_nolock($ip)";
	}';
	eval 'sub ITIMES {
	    local($ip) = @_;
	    eval "{  &mutex_enter(&($ip)-> &i_tlock);  &ITIMES_NOLOCK($ip);  &mutex_exit(&($ip)-> &i_tlock); }";
	}';
	eval 'sub FsINOS {
	    local($s5vfs, $ino) = @_;
	    eval "(((($ino) >> ($s5vfs)-> &vfs_inoshift) << ($s5vfs)-> &vfs_inoshift) + 1)";
	}';
	eval 'sub FsITOD {
	    local($s5vfs, $ino) = @_;
	    eval "( &daddr_t)(( ($ino) + (2*($s5vfs)-> &vfs_inopb-1)) >> ($s5vfs)-> &vfs_inoshift)";
	}';
	eval 'sub itod {
	    local($s5vfs, $x) = @_;
	    eval "( &daddr_t) (($x+(2*$s5vfs-> &vfs_inopb-1)) >> ($s5vfs-> &vfs_inoshift))";
	}';
	eval 'sub itoo {
	    local($s5vfs, $x) = @_;
	    eval "( &daddr_t) (($x-1)& ($s5vfs-> &vfs_inopb-1))";
	}';
	eval 'sub BMAPALLOC {
	    local($ip, $off, $size, $cr) = @_;
	    eval " &s5_bmap_write(($ip), ($off), ($size), 0, $cr)";
	}';
	eval 'sub ESAME {(-1);}';
	eval 'sub OWNER {
	    local($CR, $IP) = @_;
	    eval "((($CR)-> &cr_uid == ($IP)-> &i_uid)? 0: ( &suser($CR)? 0:  &EPERM))";
	}';
	eval 'sub S5_HOLE {( &daddr_t)0;}';
    }
    eval 'sub blkoff {
        local($s5vfs, $loc) = @_;
        eval "(($loc) & ($s5vfs)-> &vfs_bmask)";
    }';
    eval 'sub lblkno {
        local($s5vfs, $loc) = @_;
        eval "(($loc) >> ($s5vfs)-> &vfs_bshift)";
    }';
    eval 'sub blkroundup {
        local($s5vfs, $size) = @_;
        eval "((($size) + ($s5vfs)-> &vfs_bmask) & ~($s5vfs)-> &vfs_bmask)";
    }';
    if (defined( &_KERNEL) && defined( &__STDC__)) {
    }
    if (defined &__cplusplus) {
    }
}
1;
